'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SAGA_NOT_A_GENERATOR_ERROR = undefined;

var _utils = require('./utils');

var _io = require('./io');

var _io2 = _interopRequireDefault(_io);

var _proc = require('./proc');

var _proc2 = _interopRequireDefault(_proc);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SAGA_NOT_A_GENERATOR_ERROR = exports.SAGA_NOT_A_GENERATOR_ERROR = "Saga must be a Generator function";

exports.default = function () {
  for (var _len = arguments.length, sagas = Array(_len), _key = 0; _key < _len; _key++) {
    sagas[_key] = arguments[_key];
  }

  return function (_ref) {
    var getState = _ref.getState;
    var dispatch = _ref.dispatch;

    var cbs = Array(sagas.length);

    sagas.forEach(function (saga, i) {
      if (!_utils.is.generator(saga)) throw new Error(SAGA_NOT_A_GENERATOR_ERROR);

      (0, _proc2.default)(saga(_io2.default, getState), function (cb) {
        cbs[i] = cb;
        return function () {
          return (0, _utils.remove)(cbs, cb);
        };
      }, dispatch);
    });

    return function (next) {
      return function (action) {
        var result = next(action); // hit reducers
        cbs.forEach(function (cb) {
          return cb(action);
        });
        return result;
      };
    };
  };
};